﻿namespace Excavator;

/// <summary>
/// Класс-сущность "Экскаватор"
/// </summary>
public class EntityExcavator
{
   
    public int m;
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }

    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }

    /// <summary>
    /// Признак (опция) наличия ковша
    /// </summary>
    public bool Bucket { get; private set; }

    /// <summary>
    /// Признак (опция) наличия опор
    /// </summary>
    public bool Supports { get; private set; }



    /// <summary>
    /// Шаг перемещения экскаватора
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса спортивного автомобиля
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="bucket">Признак наличия ковша</param>
    /// <param name="supports">Признак наличия опор</param>

    public void Init(int speed, double weight, Color bodyColor, Color additionalColor, bool bucket, bool supports)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;
        Bucket = bucket;
        Supports = supports;
    }
}