﻿using Excavator.Drawnings;

namespace Excavator.CollectionGenericObjects;

/// <summary>
/// Реализация абстрактной компании - каршеринг 
/// </summary>
/// <remarks>
/// Конструктор
/// </remarks>
/// <param name="picWidth"></param>
/// <param name="picHeight"></param>
/// <param name="collection"></param>
public class Garage(int picWidth, int picHeight, ICollectionGenericObjects<DrawningTrackedVehicle> collection) : AbstractCompany(picWidth, picHeight, collection)
{
    Graphics g;
    int t = 5;
    protected override void DrawBackgound(Graphics g)
    {
        Pen pen = new(Color.Black, 3);
        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j < _pictureHeight / _placeSizeHeight +
            1; ++j)
            {//линия разметки места
                g.DrawLine(pen, i * _placeSizeWidth, j *
                _placeSizeHeight * 2 , i * _placeSizeWidth + _placeSizeWidth / 2, j *
                _placeSizeHeight * 2);
            }
            this.g = g;
            g.DrawLine(pen, i * _placeSizeWidth, 0, i * _placeSizeWidth, _pictureHeight / _placeSizeHeight * _placeSizeHeight * 2);
        }
    }

    protected override void SetObjectsPosition()
    {
        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;
        for (int i = 0; i < _collection.Count; i++)
        {
            DrawningTrackedVehicle? excavator = _collection.Get(i);
            if (excavator == null)
                continue;
            int r = i / width;
            int s = width - 1 - (i % width);
            excavator.SetPictureSize(_pictureWidth, _pictureHeight);
            excavator.SetPosition(s * _placeSizeWidth + t, (r * _placeSizeHeight * 2)+ t);
            excavator.DrawTransport(g);
        }
    }
}
