﻿namespace Excavator.CollectionGenericObjects;

/// <summary>
/// Параметризованный набор объектов
/// </summary>
/// <typeparam name="T">Параметр: ограничение - ссылочный тип</typeparam>
public class MassiveGenericObjects<T> : ICollectionGenericObjects<T>
    where T : class
{
    /// <summary>
    /// Массив объектов, которые храним
    /// </summary>
    private T?[] _collection;

    public int Count => _collection.Length;

    public int SetMaxCount
    {
        set
        {
            if (value > 0)
            {
                if (_collection.Length > 0)
                {
                    Array.Resize(ref _collection, value);
                }
                else
                {
                    _collection = new T?[value];
                }
            }
        }
    }

    /// <summary>
    /// Конструктор
    /// </summary>
    public MassiveGenericObjects()
    {
        _collection = Array.Empty<T?>();
    }

    public T? Get(int position)
    {
        if (position < 0 || position > Count)
        {
            return null;
        }
        return _collection[position];
    }

    public int Insert(T excavator)
    {
        return Insert(excavator, 0);
    }
    public int Insert(T excavator, int position)
    {
        int nullIndex = -1, i;
        if (!(position >= 0 && position < Count))
            return -1;
        for (i = position; i < Count; i++)
        {
            if (_collection[i] == null)
            {
                nullIndex = i;
                break;
            }
        }
        if (nullIndex < 0)
        {
            return -1;
        }
        for (i = nullIndex; i > position; i--)
        {
            _collection[i] = _collection[i - 1];
        }
        _collection[position] = excavator;
        return position;
    }

    public T Remove(int position)
    {
        if (position < 0 || position > Count)
        {
            return null;
        }
        T drawningTrackedVehicle = _collection[position];
        _collection[position] = null;

       
        return drawningTrackedVehicle;
    }
}