﻿namespace Excavator.Entities;

/// <summary>
/// Класс-сущность "Экскаватор"
/// </summary>
public class EntityExcavator : EntityTrackedVehicle
{

    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    public void SetAdditionalColor(Color additionalColor)
    {
        AdditionalColor = additionalColor;
    }

    /// <summary>
    /// Признак (опция) наличия ковша
    /// </summary>
    public bool Bucket { get; private set; }

    /// <summary>
    /// Признак (опция) наличия опор
    /// </summary>
    public bool Supports { get; private set; }



    /// <summary>
    /// Шаг перемещения экскаватора
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса экскаватора
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес экскаватора</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="bucket">Признак наличия ковша</param>
    /// <param name="supports">Признак наличия опор</param>

    public EntityExcavator(int speed, double weight, Color bodyColor, Color additionalColor, bool bucket, bool supports) : base(speed, weight, bodyColor)
    {
        AdditionalColor = additionalColor;
        Bucket = bucket;
        Supports = supports;
    }
}