﻿namespace Excavator.Entities;
/// <summary>
/// Класс-сущность "Гусеничная машина"
/// </summary>
public class EntityTrackedVehicle
{
    public int m;
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }
    public void SetBodyColor(Color bodyColor)
    {
        BodyColor = bodyColor;
    }

    /// <summary>
    /// Шаг перемещения экскаватора
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Конструктор сущности
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>


    public EntityTrackedVehicle(int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
     
    }
   

}
